
/* //////////////////////////////////////////////////////////////
                        MONT JORA RELAIS ATV F1ZEX
             Télécommande de la baie de brassage (15 entrées)
   Platine Arduino avec décodeur DTMF MT8870 & CI CD4514 (4 bits / 16 lignes)
    
    codes DTMF        codes binaire en sortie Arduino D4,5,6,7
                                  D   C   B   A   
      01*                         0   0   0   1   
      01#                         0   0   1   0    
      0123                        0   0   1   1
      0124                        0   1   0   0
      0125                        0   1   0   1
      0142                        0   1   1   0
      0143                        0   1   1   1
      0151                        1   0   0   0
      0171                        1   0   0   1
      0169                        1   0   1   0
      0139                        1   0   1   1
      0121                        1   1   0   0
      0196                        1   1   0   1
      O197                        1   1   1   0
      0198                        1   1   1   1 
      Commande maintenue 1.5 " suivie d'une information d'acquisition présente Pin D8 ("OK" en morse).
      Il est possible de controler l'acquisition en inserant un HP 8 ohms avec unerésistance de 100 ohms
      en série entre la masse et la pin 8.
      Les Codes DTMF sont modifiables mais le premier chiffre ne doit pas se retrouver dans la suite (ici 0106 serait interdit) 
      
              F5MNA mai/juin 2015  http://f5mna.free.fr
              
     Version 1.01 (janvier 2017);
   //////////////////////////////////////////////////////////////
*/

int ConfDTMF = 3;  // Confirmation de réception d'un code DTMF Pin 3
int DTMF1 = 10;    // Sortie 1 MT8870 Pin 11
int DTMF2 = 11;    // Sortie 2 MT8870     12
int DTMF3 = 12;    // Sortie 3 MT8870     13
int DTMF4 = 13;    // Sortie 4 MT8870     14
int DTMF = 0;      // Sommes sorties DTMF
int Cod = 0;       // Nbre de chiffre pris en compte
int Cd = 0 ;       // Modif Nbre de chiffres lu.
String Code;       //  codes

int val; // confirmation DTMF (ConfDTMF)
int valBt; // Bouton RAZ
int buttonState; // Prise en compte du changement d'état de la confirmation DTMF

int Buffer[25];    // Tableau mémorisation des codes entrant.
int Digit1 = 4;    // Commande brassage sur 4 digits  Pin D4
int Digit2 = 5;    //                                 Pin D5
int Digit3 = 6;    //                                 Pin D6
int Digit4 = 7;    //                                 Pin D7

//////  CW   ////////
int pinOut = 8;
int TXCW = 9;
int freq = 600;  // Fréquence
int Di = 150;
int Da = 300;
////////////////////

void setup()
{
  Serial.begin(9600);
  pinMode (ConfDTMF, INPUT); // Validation code DTMF
  pinMode (DTMF1, INPUT); // Sortie MT8870
  pinMode (DTMF2, INPUT); // Sortie MT8870
  pinMode (DTMF3, INPUT); // Sortie MT8870
  pinMode (DTMF4, INPUT); // Sortie MT8870
  pinMode (Digit1, OUTPUT); // Commande brassage sur 4 digits
  pinMode (Digit2, OUTPUT);
  pinMode (Digit3, OUTPUT);
  pinMode (Digit4, OUTPUT);
  pinMode (TXCW, OUTPUT);
  

  buttonState = digitalRead(ConfDTMF);
}

void loop ()
{
  val = digitalRead(ConfDTMF);                      //Confirmation DTMF
  if (val != buttonState) {                         // Modification de cette valeur
    if (val == LOW) {                               // Si la valeur à changé.
      Cod++;                                        // Incrementation du compteur curseur (seconde ligne)
      if (digitalRead(DTMF4) == HIGH) DTMF = DTMF + 1;
      if (digitalRead(DTMF3) == HIGH) DTMF = DTMF + 2;
      if (digitalRead(DTMF2) == HIGH) DTMF = DTMF + 4;
      if (digitalRead(DTMF1) == HIGH) DTMF = DTMF + 8;
      if (DTMF == 10) (Cod = 1);                      // DTMF == 10: Ici tous les codes doivent commencer par 0
      if (Cod == 13)  (Cod = 0);                      // Limitation nombre de codes pour ne pas saturer le buffer.
      Buffer[Cod] = DTMF;
      
      //// Controle moniteur série/////
      if ((Buffer[3] == 11) or (Buffer[3] == 12)) (Cd = 3);
      else
      Cd = 4;

      Serial.println (DTMF);
      if (Cod == Cd) {
        for (int x = 1;  x < (Cd+1); x++)
        {
          Serial.print (Buffer[x]);
        }
        Serial.println ();
      /////////////////////////////////
        Cd = 0;
        CodeCde();
      }
   
    }
  }
  buttonState = val;                                // Confirmation de la validation DTMF (CM8870)
  DTMF = 0;
  
}

void CodeCde()  // Les 15 commandes
{
  
//1
  if ((Buffer[1] ==10) and (Buffer[2] == 1) and (Buffer[3] == 11)) // 01* 
  {
    digitalWrite(Digit1, LOW);
    digitalWrite(Digit2, LOW);
    digitalWrite(Digit3, LOW);
    digitalWrite(Digit4, HIGH);
    Serial.println ("OK  01*");
    tempo();
  }

//2
  if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 12)) // 
  {
    digitalWrite(Digit1, LOW);
    digitalWrite(Digit2, LOW);
    digitalWrite(Digit3, HIGH);
    digitalWrite(Digit4, LOW);
    Serial.println ("OK  01#");
    tempo();
  }  

 //3
  if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 2) and (Buffer[4] == 3)) 
  {
    digitalWrite(Digit1, LOW);
    digitalWrite(Digit2, LOW);
    digitalWrite(Digit3, HIGH);
    digitalWrite(Digit4, HIGH);
    Serial.println ("OK  0123");
    tempo();
  } 
 //4
  if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 2) and (Buffer[4] == 4)) // 0124 
  {
    digitalWrite(Digit1, LOW);
    digitalWrite(Digit2, HIGH);
    digitalWrite(Digit3, LOW);
    digitalWrite(Digit4, LOW);
    Serial.println ("OK  0124");
     tempo();
  } 
 //5
  if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 2) and (Buffer[4] == 5)) // 0125 
  {
    digitalWrite(Digit1, LOW);
    digitalWrite(Digit2, HIGH);
    digitalWrite(Digit3, LOW);
    digitalWrite(Digit4, HIGH);
    Serial.println ("OK  0125");
    tempo();
  }

 //6
  if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 4) and (Buffer[4] == 2)) // 0142
  {
    digitalWrite(Digit1, LOW);
    digitalWrite(Digit2, HIGH);
    digitalWrite(Digit3, HIGH);
    digitalWrite(Digit4, LOW);
    Serial.println ("OK  0142");
    tempo();
  } 
 //7
  if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 4) and (Buffer[4] == 3)) // 0143
  { 
    digitalWrite(Digit1, LOW);
    digitalWrite(Digit2, HIGH);
    digitalWrite(Digit3, HIGH);
    digitalWrite(Digit4, HIGH);
    Serial.println ("OK  0143");
    tempo();
  }

 //8
  if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 5) and (Buffer[4] == 1)) // 0151
  {
    digitalWrite(Digit1, HIGH);
    digitalWrite(Digit2, LOW);
    digitalWrite(Digit3, LOW);
    digitalWrite(Digit4, LOW);
    Serial.println ("OK  0151");
    tempo();
  } 

  if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 7) and (Buffer[4] == 1)) // 0171
  {
    digitalWrite(Digit1, HIGH);
    digitalWrite(Digit2, LOW);
    digitalWrite(Digit3, LOW);
    digitalWrite(Digit4, HIGH);
    Serial.println ("OK  0171");
    tempo();
  }
//10
  if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 6) and (Buffer[4] == 9)) // 0184
  {
    digitalWrite(Digit1, HIGH);
    digitalWrite(Digit2, LOW);
    digitalWrite(Digit3, HIGH);
    digitalWrite(Digit4, LOW);
    Serial.println ("OK  0184");
     tempo();
  }  
 //11
  if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 3) and (Buffer[4] == 9)) // 0139
  {
    digitalWrite(Digit1, HIGH);
    digitalWrite(Digit2, LOW);
    digitalWrite(Digit3, HIGH);
    digitalWrite(Digit4, HIGH);
    Serial.println ("OK  0139");
    tempo();
  } 
 //12
  if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 2) and (Buffer[4] == 1)) // 0121
  {
    digitalWrite(Digit1, HIGH);
    digitalWrite(Digit2, HIGH);
    digitalWrite(Digit3, LOW);
    digitalWrite(Digit4, LOW);
    Serial.println ("OK  0121");
    tempo();
  } 
 //13
  if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 9) and (Buffer[4] == 6)) // 0196
  {
    digitalWrite(Digit1, HIGH);
    digitalWrite(Digit2, HIGH);
    digitalWrite(Digit3, LOW);
    digitalWrite(Digit4, HIGH);
    Serial.println ("OK  0196");
    tempo();
  }
 //14
  if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 9) and (Buffer[4] == 7)) 
  {
    digitalWrite(Digit1, HIGH);
    digitalWrite(Digit2, HIGH);
    digitalWrite(Digit3, HIGH);
    digitalWrite(Digit4, LOW);
    Serial.println ("0197");
    tempo();
  } 

 //15
  if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 9) and (Buffer[4] == 8)) 
  {
    digitalWrite(Digit1, HIGH);
    digitalWrite(Digit2, HIGH);
    digitalWrite(Digit3, HIGH);
    digitalWrite(Digit4, HIGH);
    Serial.println ("OK  0198");
    tempo();
  } 
}

void tempo()  // Duréee de la commande
{
    digitalWrite(TXCW, HIGH);  // TX en marche
    delay (1000);               // Cde maintenue 1.5"
    digitalWrite(Digit1, LOW);
    digitalWrite(Digit2, LOW);
    digitalWrite(Digit3, LOW);
    digitalWrite(Digit4, LOW);
    Serial.println ("Fin tempo"); 
    Morse();
}    
 
void Morse()
{
   /////  "OK" CW  ////// 
    //digitalWrite(TXCW, HIGH);  // TX en marche
    //delay (500); 
    tone(pinOut, freq, Da);
    delay (Da);
    tone(pinOut, freq, Da);
    delay (Da);
    tone(pinOut, freq, Da);
    delay (Da*3);  
    tone(pinOut, freq, Da);
    delay (Da);
    tone(pinOut, freq, Di);
    delay (Da);
    tone(pinOut, freq, Da);
    delay (Da*6);
    digitalWrite(TXCW, LOW);  // TX Arrêt
  } 
